#include "TagByteArray.h"

#include "TagInt.h"

#include <QtCore/QDataStream>

TagByteArray::TagByteArray (const QList<TagByte> value) : AbstractNamedTag(ID), m_value(value) {}

const QList<TagByte> &TagByteArray::value () const {
    return m_value;
}

void TagByteArray::readPayloadFromData (QDataStream &data) {
    TagInt size;
    data >> size;

    m_value.clear();
    for (qint32 elem = 0; elem < size.value(); elem++) {
        TagByte tag;
        tag.readPayloadFromData(data);

        m_value << tag;
    }
}
void TagByteArray::writePayloadToData (QDataStream &data) const {
    TagInt size(m_value.size());

    data << size;
        foreach(const TagByte tag, m_value) {
            data << tag;
        }
}