#include "TagList.h"

#include "TagByte.h"
#include "TagInt.h"

#include <QtCore/QDataStream>

TagList::TagList (quint8 elementsId, const QList<AbstractTag> value) : AbstractNamedTag(ID) {
    m_elementsId = elementsId;

    m_value.clear();
    foreach(const AbstractTag &tag, value) {
        if(tag.id() == m_elementsId) {
            m_value.append(tag);
        }
    }
}

const quint8 TagList::elementsId() const {
    return m_element;
}
const QList<AbstractTag> &TagList::value () const {
    return m_value;
}

void TagList::readPayloadFromData (QDataStream &data) {
    TagInt size;
    data >> size;

    m_value.clear();
    for (qint32 elem = 0; elem < size.value(); elem++) {
        TagByte tag;
        data >> tag;

        m_value << tag;
    }
}
void TagList::writePayloadToData (QDataStream &data) const {
    TagInt size(m_value.size());

    data << size;
        foreach(const AbstractTag &tag, m_value) {
            data << tag;
        }
}
