#include "TagString.h"

#include "TagShort.h"

#include <QtCore/QDataStream>

TagString::TagString (const QString &value) : AbstractNamedTag(ID), m_value(value) {}

const QString &TagString::value () const {
    return m_value;
}

void TagString::readPayloadFromData (QDataStream &data) {
    TagShort size;
    data >> size;

    QByteArray string(size.value(), '\0');
    for (qint16 elem = 0; elem < size.value(); elem++) {
        qint8 byte;
        data >> byte;

        string[elem] = byte;
    }

    m_value = QString::fromUtf8(string);
}
void TagString::writePayloadToData (QDataStream &data) const {
    const QByteArray string(m_value.toUtf8());
    const TagShort size(string.size());

    data << size;
    for (qint16 elem = 0; elem < size.value(); elem++) {
        data << string.at(elem);
    }
}