#include <QtCore/QSettings>
#include <QtWidgets/QApplication>

#include "MainWindow/MainWindow.h"

int main (int argc, char *argv[]) {
    QApplication app(argc, argv);
    QApplication::setAttribute(Qt::AA_UseHighDpiPixmaps);
    QApplication::setOrganizationName("JRosset");
    QApplication::setOrganizationDomain("jrosset.fr");
    QApplication::setApplicationName("NBTModifier");
    app.setQuitOnLastWindowClosed(true);

    QSettings settings;
    const bool dark = (settings.value("application/theme", "dark").toString() == "dark");
    QIcon::setThemeName(QString("breeze") + (dark ? QString("-dark") : QString()));

    MainWindow main;
    main.show();

    return app.exec();
}
