#include "AbstractNumeric.h"

#include <QtEndian>
#include <QtCore/QDataStream>

template<typename T>
NBT::Payload::AbstractNumeric<T>::AbstractNumeric (T const value): m_value(value) {
}

template<typename T>
const T NBT::Payload::AbstractNumeric<T>::value () const {
    return m_value;
}
template<typename T>
void NBT::Payload::AbstractNumeric<T>::setValue (T const value) {
    m_value = value;
}

template<typename T>
void NBT::Payload::AbstractNumeric<T>::readFromData (QDataStream &stream) {
    stream >> m_value;
    m_value = qFromBigEndian(m_value);
}
template<typename T>
void NBT::Payload::AbstractNumeric<T>::writeToData (QDataStream &stream) const {
    stream << qToBigEndian(m_value);
}
